Package org.jcsp.plugNplay.ints

# Class OrInt

java.lang.Object
org.jcsp.plugNplay.ints.OrInt

All Implemented Interfaces:
  `CSProcess`

public final class OrInt extends Object implements CSProcess
Bitwise ors two integer streams to one stream.

## Process Diagram

        in0  _______
       -->--|       | out
        in1 | OrInt |-->--
       -->--|_______|

## Description

`OrInt` is a process whose output strean is the bitwise or of the integers on its input streams.

## Channel Protocols

Input Channels
in0, in1 | int | All channels in this package carry integers.
Output Channels
out | int | All channels in this package carry integers.

## Example

The following example shows how to use the OrInt process in a small program. The program also uses some of the other building block processes. The program generates a sequence of numbers and rounds each even number up to the nearest odd number and prints this on the screen.

     import org.jcsp.lang.*;
     import org.jcsp.plugNplay.ints.*;

     public class OrIntExample {

       public static void main (String[] argv) {

         final One2OneChannelInt a = Channel.one2oneInt ();
         final One2OneChannelInt b = Channel.one2oneInt ();
         final One2OneChannelInt c = Channel.one2oneInt ();

         new Parallel (
           new CSProcess[] {
             new NumbersInt (a.out ()),
             new GenerateInt (b.out (), 1),
             new OrInt (a.in (), b.in (), c.out ()),
             new PrinterInt (c.in (), "--> ", "\n")
           }
         ).run ();

       }

     }

Author:
  P.H. Welch and P.D. Austin

## Constructor Summary

Constructors
Constructor
Description
`OrInt(ChannelInputInt in0, ChannelInputInt in1, ChannelOutputInt out)`
Construct a new OrInt process with the input Channels in0 and in1 and the output Channel out.

## Method Summary

Modifier and Type
Method
Description
`void`
`run()`
The main body of this process.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### OrInt

public OrInt(ChannelInputInt in0, ChannelInputInt in1, ChannelOutputInt out)
Construct a new OrInt process with the input Channels in0 and in1 and the output Channel out. The ordering of the Channels in0 and in1 make no difference to the functionality of this process.

Parameters:
  `in0` - the first input Channel
  `in1` - the second input Channel
  `out` - the output Channel

## Method Details

### run

public void run()
The main body of this process.

Specified by:
  `run` in interface `CSProcess`